
;display QWORD demo program - dedndave

        .MODEL  SMALL
        .STACK  512

;-------------------------------------------------------------------------------

        .DATA

QwTest  dq 0FEDBA9876543210h

CrLf    db 0Dh,0Ah,24h

AscBuf  db 17 dup(?)

;-------------------------------------------------------------------------------

        .CODE

_main   PROC    FAR

;set video mode 3

        mov     ax,3
        int     10h

;initialize the DS register

        mov     ax,@DATA
        mov     ds,ax

;convert the binary QWORD to ASCIIZ hexidecimal

        mov     si,offset QwTest
        mov     di,offset AscBuf
        mov     cx,sizeof QwTest
        call    MB2Hex

;display the ASCIIZ string

        cld
        mov     si,di
        mov     ax,0B800h
        mov     es,ax
        xor     di,di
        mov     ah,7
        call    Dsply

;display a carriage return/line feed

        mov     dx,offset CrLf
        mov     ah,9
        int     21h

;terminate

        mov     ax,4C00h
        int     21h

_main   ENDP

;-------------------------------------------------------------------------------

MB2Hex  PROC    NEAR

;convert a multi-byte binary from a memory location to ASCIIZ hexidecimal string

;Call With: DS:SI = address of binary input value
;           DS:DI = address of ASCII buffer (minimum length = 2 x CX + 1)
;              CX = number of binary input bytes to convert

        push    ax
        push    cx
        push    di
        add     si,cx

MB2Hx0: dec     si
        mov     al,[si]
        mov     ah,al
        shr     al,1
        shr     al,1
        shr     al,1
        shr     al,1
        cmp     al,0Ah
        sbb     al,69h
        das
        mov     [di],al
        inc     di
        mov     al,ah
        and     al,0Fh
        cmp     al,0Ah
        sbb     al,69h
        das
        mov     [di],al
        inc     di
        dec     cx
        jnz     MB2Hx0

        mov     [di],cl
        pop     di
        pop     cx
        pop     ax
        ret

MB2Hex  ENDP

;-------------------------------------------------------------------------------

Dsply   PROC    NEAR

        jmp short Dsply1

Dsply0: stosw

Dsply1: lodsb
        or      al,al
        jnz     Dsply0

        ret

Dsply   ENDP

;-------------------------------------------------------------------------------

        END     _main

